/********************************************************************/
/********************************************************************/
/*****                                                          *****/
/*****        L A B C E N T E R    E L E C T R O N I C S        *****/
/*****                                                          *****/
/*****       LABCENTER INTEGRATED SIMULATION ARCHITECTURE       *****/
/*****                                                          *****/
/*****             Header File for 4-Bit LCD Sample             *****/
/*****                                                          *****/
/********************************************************************/
/********************************************************************/      
                                                                                            
/*typedef void VOID;                                                                          
typedef int  INT;                                                                           
typedef signed char INT8;
typedef signed int  INT16;
typedef signed long INT32;
typedef unsigned short WORD;                                                                
typedef char CHAR;                                                                          
typedef unsigned char BYTE;                                                                 
typedef float FLOAT;                                                                        
typedef double DOUBLE;                                                                      
typedef long LONG;                                                                          
typedef INT8 BOOL;
*/
                                                                                           
//Display Config.
#define MAX_DISPLAY_CHAR 15    

//LCD Registers addresses (PORT B)
#define LCD_CMD_WR	    0x00
#define LCD_DATA_WR	    0x01
#define LCD_BUSY_RD	    0x02
#define LCD_DATA_RD	    0x03
      
// Keypad Config.
#define KEYP_NUM_ROWS 4
#define KEYP_NUM_COLS 3
               
//LCD Commands        
#define LCD_CLS		    0x01
#define LCD_HOME	    0x02
#define LCD_SETMODE	    0x04
#define LCD_SETVISIBLE  0x08
#define LCD_SHIFT	    0x10 
#define LCD_SETFUNCTION	0x2B
#define LCD_SETCGADDR	0x40
#define LCD_SETDDADDR	0x80
#define LCD_LINE1 		0x80
#define LCD_LINE2 		0xC0 
#define E_PIN_MASK      0x04
#define EN 				PORTDbits.RD0  	//Pin for RE
#define RW 				PORTDbits.RD1 	//Pin for RW
#define RS 				PORTDbits.RD2	//Pin for RS
#define BusyFlag 		PORTDbits.RD7	//Pin for Busy Flag
#define NOP             asm("NOP")
#define FALSE 0
#define TRUE  1                                                       
                                                                                            
//Error handling status.                                                                    
enum ERROR     { OK = 0, SLEEP = 1, ERROR = 2};                                                 
                                                                                               
/************************************************************************                   
***** FUNCTION PROTOTYPES *****                                                             
******************************/   
// Keypad Functions.
char keypadread(); 
char scankeypad();
char getkey (void); 
void display (const char *buf);
void evaluate();
void lcd_line(int line);
void lcd_init(void);
void lcd_wait(void);
void clearscreen(void);
void wrcmd (char data);
void wrdata(char data);
void wrcgchr(unsigned char *arrayptr, int offset);
void pause(int num);
void eat(void);
void clear(void);

