//usart.c
#include <usart.h>
#include <p18f6585.h>
#include <conio.h>

#define TX_485_ENABLE TRISCbits.TRISC5

void InitUsart(void) {

	TRISCbits.TRISC6 = 0;	// TX Pin - izhod
	TRISCbits.TRISC7 = 1;	// RX Pin - vhod
	RCSTA = 0x90;			// RX Setting, 8bit, enable receive
	TXSTA = 0x24;			// TX Setting, 8bit, Asinchronius mode, High speed
	BAUDCON = 0x00; // priemane aktivno, RX ne se nabliudava
	SPBRG = 103;	// Set Baudrade - 2400 - Error 0.16% (from datasheet baudrate table)
}

void UsartWriteChar(unsigned char ch) {
   
	while(!TXSTAbits.TRMT) 	// TRMT1 is set when TSR is empty
      continue;
	TXREG = ch;		// load the register

}

unsigned char UsartReadChar(void) {
	while(!PIR1bits.RCIF) 
		continue;                         
    return RCREG; 
}

unsigned char UsartReadChar_nonstop(void) {

	if(!PIR1bits.RCIF) 	// TRMT1 is set when TSR is empty
      return 0;   

    return RCREG; 
}

void UsartWriteText(const rom char *txt) {
	unsigned char i = 0;
	while(txt[i]!='\0') {
		UsartWriteChar(txt[i]);
		i++;
	}

}
void USART_activa_tx(void){
  TX_485_ENABLE = 1;
  //Delay(5);
}
void USART_activa_rx(void){
  TX_485_ENABLE = 0;
  //Delay(5);
}

